/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2007, 2008, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdarg.h>

extern int source_info_option;

void debug_init(char **names);
size_t debug_next_handle(void);
int debug_level_p(int modn, int level);
void debug_enable_module(const char *file, int level);
int debug_module_level(const char *modname, int *plev);
void debug_parse_spec(const char *spec);
void debug_log(char *fmt, ...);
void debug_vlog(char *fmt, va_list ap);
void debug_locus(const char *file, int line, const char *fun);

int debug_spec_string(const char *spec, int minlevel, int showunset,
		      char **pbuf);
size_t debug_register(char *name);

#define __debug(s)							\
	do {								\
		if (source_info_option)					\
			debug_locus(__FILE__, __LINE__, __FUNCTION__);	\
		debug_log s;						\
 } while (0)                                                                  

#define debug(mod,lev,s)						\
	do { if (debug_level_p(mod, lev)) __debug(s); } while(0)
